#include "product.h"
#include "chess.h"
FILE *input_stream = NULL;
FILE *book_file = NULL;
FILE *books_file = NULL;
FILE *normal_bs_file = NULL;
FILE *computer_bs_file = NULL;
FILE *history_file = NULL;
FILE *log_file = NULL;
FILE *eval_file = NULL;
FILE *eval_tex_file = NULL;
FILE *eval_ctl_file = NULL;
int tex_cnt = 0;
int done = 0;
UINT64 total_moves;
int last_mate_score;
char log_filename[256];
char history_filename[256];
char book_filename[256];
char books_filename[256];
char bookc_filename[256];
int number_of_solutions;
int solutions[10];
int solution_type;
char cmd_buffer[4096];
char *args[512];
char buffer[4096];
int line_length = 80;
unsigned char convert_buff[8];
int nargs;
int ponder_value;
int move_actually_played;
int ponder_move;
int ponder_moves[220];
int num_ponder_moves;
int book_move;
int book_learn_eval[LEARN_INTERVAL];
int book_learn_depth[LEARN_INTERVAL];
int learn_positions_count = 0;
int learn_seekto[64];
UINT64 learn_key[64];
int learn_nmoves[64];
int book_learn_nmoves;
int book_learn_seekto;
UINT64 book_learn_key;
UINT64 hash_mask;
UINT64 pawn_hash_mask;
HASH_ENTRY *trans_ref = NULL;
HPATH_ENTRY *hash_path = NULL;
PAWN_HASH_ENTRY *pawn_hash_table = NULL;
size_t cb_trans_ref;
size_t cb_pawn_hash_table;
UINT64 eval_hash_mask = 65536 - 1;
void * segments[MAX_BLOCKS + 32][2];
int nsegments = 0;
PATH last_pv;
int last_value;
int king_safety[16][16];
int mob_curve_r[48] = {
  -27,-23,-21,-19,-15,-10, -9, -8,
   -7, -6, -5, -4, -3, -2, -1,  0,
    1,  2,  3,  4,  5,  6,  7,  8,
    9, 10, 11, 12, 13, 14, 15, 16,
   17, 18, 19, 20, 21, 22, 23, 24,
   25, 26, 27, 28, 29, 30, 31, 32
};
int mob_curve_r_last[48] = {
  -27,-23,-21,-19,-15,-10, -9, -8,
   -7, -6, -5, -4, -3, -2, -1,  0,
    1,  2,  3,  4,  5,  6,  7,  8,
    9, 10, 11, 12, 13, 14, 15, 16,
   17, 18, 19, 20, 21, 22, 23, 24,
   25, 26, 27, 28, 29, 30, 31, 32
};
signed char directions[64][64];
BITBOARD pawn_attacks[2][64];
BITBOARD knight_attacks[64];
BITBOARD king_attacks[64];
BITBOARD obstructed[64][64];
BITBOARD randoms[2][7][64];
BITBOARD castle_random[2][2];
BITBOARD enpassant_random[MAXPLY];
BITBOARD wtm_random[2];
BITBOARD clear_mask[MAXPLY];
BITBOARD set_mask[MAXPLY];
BITBOARD file_mask[8];
BITBOARD rank_mask[8];
BITBOARD OO[2] = { 0x6000000000000000ULL, 0x0000000000000060ULL };
BITBOARD OOO[2] = { 0x0E00000000000000ULL, 0x000000000000000EULL };
BITBOARD mask_efgh, mask_fgh, mask_abc, mask_abcd;
BITBOARD mask_advance_2_w;
BITBOARD mask_advance_2_b;
BITBOARD mask_can_promote_w;
BITBOARD mask_can_promote_b;
BITBOARD mask_left_edge;
BITBOARD mask_right_edge;
BITBOARD mask_not_edge;
BITBOARD mask_kr_trapped[2][3];
BITBOARD mask_qr_trapped[2][3];
BITBOARD mask_space[2];
BITBOARD mask_board_quarter[4];
BITBOARD dark_squares;
BITBOARD not_rook_pawns;
BITBOARD rook_pawns;
BITBOARD plus1dir[MAXPLY];
BITBOARD plus7dir[MAXPLY];
BITBOARD plus8dir[MAXPLY];
BITBOARD plus9dir[MAXPLY];
BITBOARD minus1dir[MAXPLY];
BITBOARD minus7dir[MAXPLY];
BITBOARD minus8dir[MAXPLY];
BITBOARD minus9dir[MAXPLY];
BITBOARD mask_eptest[64];
BITBOARD mask_clear_entry;
KILLER counter_move[4096];
KILLER move_pair[4096];
int history[2][512];
POSITION display;
#if (!defined(_M_AMD64) && !defined(_M_IA64) && !defined(INLINE32)) || defined(VC_INLINE)
unsigned char msb[65536];
unsigned char lsb[65536];
#endif
unsigned char msb_8bit[256];
unsigned char lsb_8bit[256];
unsigned char pop_cnt_8bit[256];
signed char is_outside[256][256];
BITBOARD mask_pawn_connected[2][64];
BITBOARD mask_pawn_duo[64];
BITBOARD mask_pawn_isolated[64];
BITBOARD mask_pawn_passed[2][64];
BITBOARD mask_no_pattacks[2][64];
BITBOARD mask_hidden_left[2][8];
BITBOARD mask_hidden_right[2][8];
BITBOARD pawn_race[2][2][64];
BOOK_POSITION book_buffer[BOOK_CLUSTER_SIZE];
BOOK_POSITION book_buffer_char[BOOK_CLUSTER_SIZE];
int OOsqs[2][3] = { {E8, F8, G8}, {E1, F1, G1} };
int OOOsqs[2][3] = { {E8, D8, C8}, {E1, D1, C1} };
int OOfrom[2] = { E8, E1 };
int OOto[2] = { G8, G1 };
int OOOto[2] = { C8, C1 };
#if defined(_WIN32) || defined(_WIN64)
char version[64] = { PRODUCT_VERSION };
#else
char version[] = { PRODUCT_VERSION };
#endif
PLAYING_MODE mode = normal_mode;
int batch_mode = 0;             /* no asynch reads */
int swindle_mode = 0;           /* try to swindle */
int call_flag = 0;
int crafty_rating = 2500;
int opponent_rating = 2500;
int last_search_value = 0;
int lazy_eval_cutoff[2] = {125, 180};
int lazy_eval_cutoff_last[2] = {125, 180};
int pruning_depth = 5;
int pruning_depth_last = 5;
int movecnt_depth = 3;
int movecnt_depth_last = 3;
int singular_extension_margin = 30;
int singular_extension_margin_last = 30;
int probcut_margin = 500;
int probcut_margin_last = 500;
int late_moves_margin = 325;
int late_moves_margin_last = 325;
int lmr_scale = 100;
int lmr_scale_last = 100;
int history_max_moves = HISTORY_MAX_MOVES;
int history_max_moves_last = HISTORY_MAX_MOVES;
int king_safety_scale = 100; /*108 216 324 120*/
int king_safety_scale_last = 100; /*108 216 324 120*/
int pruning_margin[8] =
  {0, 120, 120, 310, 310, 400, 400, 500};
int pruning_margin_last[8] =
  {0, 120, 120, 310, 310, 400, 400, 500};
int pruning_proportion[8] =
  {200, 100, 252, 100, 100, 100, 100, 100};
int pruning_proportion_last[8] =
  {200, 100, 252, 100, 100, 100, 100, 100};
int movecnt_margin[8] = {0, 12, 15, 18, 0, 0, 0, 0};
int movecnt_margin_last[8] = {0, 12, 15, 18, 0, 0, 0, 0};
/*int movecnt_margin[8] = {0, 12, 15, 19, 25, 32, 40, 49};
int movecnt_margin_last[8] = {0, 12, 15, 19, 25, 32, 40, 49};*/
int quiesce_futility_margin = 125;
int quiesce_futility_margin_last = 125;
int pgn_suggested_percent = 0;
char pgn_event[128] = { "?" };
char pgn_site[128] = { "?" };
char pgn_date[128] = { "????.??.??" };
char pgn_round[128] = { "?" };
char pgn_white[128] = { "unknown" };
char pgn_white_elo[128] = { "" };
char pgn_black[128] = { "Vafra " PRODUCT_VERSION };
char pgn_black_elo[128] = { "" };
char pgn_result[128] = { "*" };
char *B_list[128];
char *AK_list[128];
char *C_list[128];
char *GM_list[128];
char *IM_list[128];
char *SP_list[128];
char *SP_opening_filename[128];
char *SP_personality_filename[128];
char personality_comment[128];
int ics = 0;
int output_format = 0;
#if !defined(NOEGTB)
int EGTBlimit = 0;
int EGTB_use = 0;
int EGTB_draw = 0;
int EGTB_search = 0;
size_t EGTB_cache_size = EGTB_CACHE_DEFAULT;
void *EGTB_cache = (void *) 0;
int EGTB_setup = 0;
#endif
int NNUE_setup = 0;
int xboard = 0;
int pong = 0;
int channel = 0;
int early_exit = 99;
int test_running = 0;
BITBOARD test_score_diff = 0;
int test_score_threshold = 0;
int new_game = 0;
char channel_title[32] = { "" };
char personality[64] = { "" };
char personality_last[64] = { "" };
char book_path[128] = { BOOKDIR };
char log_path[128] = { LOGDIR };
char tb_path[128] = { TBDIR };
char nnue_file[128] = { "" };
char rc_path[128] = { RCDIR };
int initialized = 0;
int kibitz = 0;
int post = 0;
int log_id = 0;
int log_trace = 0;
int wtm = 1;
int last_opponent_move = 0;
int search_pruning_flags = (DO_NULL_MOVE | DO_FUTILITY | DO_REDUCTIONS);
int search_pruning_flags_last = (DO_NULL_MOVE | DO_FUTILITY | DO_REDUCTIONS);
int search_quiescent_flags = (DO_QCHECKS);
int search_quiescent_flags_last = (DO_QCHECKS);
int search_flags = DO_NOTHING;
int search_flags_last = DO_NOTHING;
int extension_depth[16] = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int extension_depth_last[16] = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int quiesce_check_depth = 1;
int quiesce_check_depth_last = 1;
int reduce_null_depth[2] = {3, 3}; /* R=3 R=3 */
int reduce_null_depth_last[2] = {3, 3};
int reduce_depth[2] = {2, 2}; /* R=2 R=2 */
int reduce_depth_last[2] = {2, 2};
int LMR_min_depth[2] = {2, 2}; /* leave LMR_min_depth plies after reductions */
int LMR_min_depth_last[2] = {2, 2};
int LMR_max_plies = 9; /* max reduction plies */
int LMR_max_plies_last = 9;
int lmr_max_plies = 0;
int reductions[2][2][32][64]; /* reduce for reductions plies */
int popcnt64 = 0;
int aspiration_window = ASPIRATION_WINDOW;
int aspiration_window_last = ASPIRATION_WINDOW;
int search_depth = 0;
#if defined(_WIN32) || defined(_WIN64)
HANDLE timer_handle_search = NULL;
#endif
unsigned int search_nodes = 0;
unsigned int temp_search_nodes = 0;
int search_move = 0;
int predicted = 0;
int time_used = 0;
int time_used_opponent = 0;
int analyze_mode = 0;
int annotate_mode = 0;
int input_status = 0;
int resign = 9;
int computer_resign = 5;
int resign_counter = 0;
int resign_count = 5;
int draw_counter = 0;
int draw_count = 5;
int draw_offer_pending = 0;
int draw_offered = 0;
int offer_draws = 1;
int adaptive_hash = 0;
size_t adaptive_hash_min = 0;
size_t adaptive_hash_max = 0;
size_t adaptive_hashp_min = 0;
size_t adaptive_hashp_max = 0;
int time_limit = 100;
int force = 0;
char initial_position[80] = { "" };
char hint[512] = { "" };
char book_hint[512] = { "" };
int over = 0;
int silent = 0;
int usage_level = 0;
char audible_alarm = 0x07;
char speech = 0;
int ansi = 1;
int book_accept_mask = ~03;
int book_reject_mask = 3;
int book_random = 1;
float book_weight_learn = 1.0;
float book_weight_freq = 1.0;
float book_weight_eval = 0.1;
int book_search_trigger = 20;
int learning = 7;
int time_abort;
int abort_search;
int iteration_depth;
int maximum_ply;
int root_alpha;
int root_beta;
int root_value;
int root_wtm;
int last_root_value;
ROOT_MOVE root_moves[256];
int n_root_moves;
int best_root_capture = 0;
int root_material_evaluation;
int difficulty;
int time_limit;
int absolute_time_limit = 0;
int search_time_limit = 0;
int burp;
volatile int quit;
unsigned int opponent_start_time, opponent_end_time;
unsigned int program_start_time, program_end_time;
unsigned int start_time, end_time;
unsigned int elapsed_start, elapsed_end;
unsigned int program_start_cpu_time, program_end_cpu_time;
TREE *block[MAX_BLOCKS + 1];
TREE *volatile thread[CPUS];
#if (CPUS > 1)
lock_t lock_smp, lock_io, lock_root, lock_his;
#if defined(UNIX)
  pthread_attr_t attributes;
#endif
#endif
unsigned int parallel_splits;
unsigned int parallel_aborts;
unsigned int max_split_blocks;
volatile int smp_idle = 0;
volatile int smp_threads = 0;
volatile int initialized_threads = 0;
int crafty_is_white = 0;
int average_nps = 0;
unsigned int nodes_per_second = 1000000;
int time_check = 0;
int transposition_age = 0;
int thinking = 0;
int pondering = 0;
int puzzling = 0;
int booking = 0;
int trojan_check = 0;
int computer_opponent = 0;
int display_options = 4095 - 256 - 512;
int dont_log = 0;
int smp_max_threads = 0;
int max_thread_group = 4;
int split_at_root = 1;
unsigned int noise_level = 100;
int tc_moves = 60;
int tc_time = 180000;
int tc_time_remaining[2] = { 180000, 180000 };
int tc_moves_remaining[2] = { 60, 60 };
int tc_secondary_moves = 30;
int tc_secondary_time = 90000;
int tc_increment = 0;
int tc_sudden_death = 0;
int tc_operator_time = 0;
int tc_safety_margin = 0;
int draw_score[2] = { 0, 0 };
char kibitz_text[512];
int kibitz_iteration_depth = 0;
int kibitz_maximum_ply = 0;
int kibitz_iteration_depth_last = 0;
int kibitz_maximum_ply_last = 0;
int kibitz_maximum_ply_last_last = 0;
int move_number = 1;
int root_print_ok = 0;
int moves_out_of_book = 0;
int first_nonbook_factor = 0;
int first_nonbook_span = 0;
int smp_nice = 1;
#if defined(SKILL)
int skill = 100;
#endif
int show_book = 0;
int book_selection_width = 5;
int computer_book_selection_width = 2;
int ponder = 1;
int trace_level = 0;
size_t hash_table_size = 65536;
size_t hash_path_size = 65536;
UINT64 hash_path_mask = (65536 - 1) & ~15;
int log_hash = 16;
size_t pawn_hash_table_size = 16384;
int log_pawn_hash = 14;
int abs_draw_score = 0;
int abs_draw_score_last = 0;
int accept_draws = 1;
const char translate[13] =
    { 'k', 'q', 'r', 'b', 'n', 'p', 0, 'P', 'N', 'B', 'R', 'Q', 'K' };
BITBOARD magic_bishop[64] = {
  0x0002020202020200ULL, 0x0002020202020000ULL, 0x0004010202000000ULL,
  0x0004040080000000ULL, 0x0001104000000000ULL, 0x0000821040000000ULL,
  0x0000410410400000ULL, 0x0000104104104000ULL, 0x0000040404040400ULL,
  0x0000020202020200ULL, 0x0000040102020000ULL, 0x0000040400800000ULL,
  0x0000011040000000ULL, 0x0000008210400000ULL, 0x0000004104104000ULL,
  0x0000002082082000ULL, 0x0004000808080800ULL, 0x0002000404040400ULL,
  0x0001000202020200ULL, 0x0000800802004000ULL, 0x0000800400A00000ULL,
  0x0000200100884000ULL, 0x0000400082082000ULL, 0x0000200041041000ULL,
  0x0002080010101000ULL, 0x0001040008080800ULL, 0x0000208004010400ULL,
  0x0000404004010200ULL, 0x0000840000802000ULL, 0x0000404002011000ULL,
  0x0000808001041000ULL, 0x0000404000820800ULL, 0x0001041000202000ULL,
  0x0000820800101000ULL, 0x0000104400080800ULL, 0x0000020080080080ULL,
  0x0000404040040100ULL, 0x0000808100020100ULL, 0x0001010100020800ULL,
  0x0000808080010400ULL, 0x0000820820004000ULL, 0x0000410410002000ULL,
  0x0000082088001000ULL, 0x0000002011000800ULL, 0x0000080100400400ULL,
  0x0001010101000200ULL, 0x0002020202000400ULL, 0x0001010101000200ULL,
  0x0000410410400000ULL, 0x0000208208200000ULL, 0x0000002084100000ULL,
  0x0000000020880000ULL, 0x0000001002020000ULL, 0x0000040408020000ULL,
  0x0004040404040000ULL, 0x0002020202020000ULL, 0x0000104104104000ULL,
  0x0000002082082000ULL, 0x0000000020841000ULL, 0x0000000000208800ULL,
  0x0000000010020200ULL, 0x0000000404080200ULL, 0x0000040404040400ULL,
  0x0002020202020200ULL
};
BITBOARD magic_bishop_mask[64] = {
  0x0040201008040200ULL, 0x0000402010080400ULL, 0x0000004020100A00ULL,
  0x0000000040221400ULL, 0x0000000002442800ULL, 0x0000000204085000ULL,
  0x0000020408102000ULL, 0x0002040810204000ULL, 0x0020100804020000ULL,
  0x0040201008040000ULL, 0x00004020100A0000ULL, 0x0000004022140000ULL,
  0x0000000244280000ULL, 0x0000020408500000ULL, 0x0002040810200000ULL,
  0x0004081020400000ULL, 0x0010080402000200ULL, 0x0020100804000400ULL,
  0x004020100A000A00ULL, 0x0000402214001400ULL, 0x0000024428002800ULL,
  0x0002040850005000ULL, 0x0004081020002000ULL, 0x0008102040004000ULL,
  0x0008040200020400ULL, 0x0010080400040800ULL, 0x0020100A000A1000ULL,
  0x0040221400142200ULL, 0x0002442800284400ULL, 0x0004085000500800ULL,
  0x0008102000201000ULL, 0x0010204000402000ULL, 0x0004020002040800ULL,
  0x0008040004081000ULL, 0x00100A000A102000ULL, 0x0022140014224000ULL,
  0x0044280028440200ULL, 0x0008500050080400ULL, 0x0010200020100800ULL,
  0x0020400040201000ULL, 0x0002000204081000ULL, 0x0004000408102000ULL,
  0x000A000A10204000ULL, 0x0014001422400000ULL, 0x0028002844020000ULL,
  0x0050005008040200ULL, 0x0020002010080400ULL, 0x0040004020100800ULL,
  0x0000020408102000ULL, 0x0000040810204000ULL, 0x00000A1020400000ULL,
  0x0000142240000000ULL, 0x0000284402000000ULL, 0x0000500804020000ULL,
  0x0000201008040200ULL, 0x0000402010080400ULL, 0x0002040810204000ULL,
  0x0004081020400000ULL, 0x000A102040000000ULL, 0x0014224000000000ULL,
  0x0028440200000000ULL, 0x0050080402000000ULL, 0x0020100804020000ULL,
  0x0040201008040200ULL
};
unsigned int magic_bishop_shift[64] = {
  58, 59, 59, 59, 59, 59, 59, 58,
  59, 59, 59, 59, 59, 59, 59, 59,
  59, 59, 57, 57, 57, 57, 59, 59,
  59, 59, 57, 55, 55, 57, 59, 59,
  59, 59, 57, 55, 55, 57, 59, 59,
  59, 59, 57, 57, 57, 57, 59, 59,
  59, 59, 59, 59, 59, 59, 59, 59,
  58, 59, 59, 59, 59, 59, 59, 58
};
BITBOARD magic_bishop_table[5248];
BITBOARD *magic_bishop_indices[64] = {
  magic_bishop_table + 4992, magic_bishop_table + 2624,
  magic_bishop_table + 256, magic_bishop_table + 896,
  magic_bishop_table + 1280, magic_bishop_table + 1664,
  magic_bishop_table + 4800, magic_bishop_table + 5120,
  magic_bishop_table + 2560, magic_bishop_table + 2656,
  magic_bishop_table + 288, magic_bishop_table + 928,
  magic_bishop_table + 1312, magic_bishop_table + 1696,
  magic_bishop_table + 4832, magic_bishop_table + 4928,
  magic_bishop_table + 0, magic_bishop_table + 128,
  magic_bishop_table + 320, magic_bishop_table + 960,
  magic_bishop_table + 1344, magic_bishop_table + 1728,
  magic_bishop_table + 2304, magic_bishop_table + 2432,
  magic_bishop_table + 32, magic_bishop_table + 160,
  magic_bishop_table + 448, magic_bishop_table + 2752,
  magic_bishop_table + 3776, magic_bishop_table + 1856,
  magic_bishop_table + 2336, magic_bishop_table + 2464,
  magic_bishop_table + 64, magic_bishop_table + 192,
  magic_bishop_table + 576, magic_bishop_table + 3264,
  magic_bishop_table + 4288, magic_bishop_table + 1984,
  magic_bishop_table + 2368, magic_bishop_table + 2496,
  magic_bishop_table + 96, magic_bishop_table + 224,
  magic_bishop_table + 704, magic_bishop_table + 1088,
  magic_bishop_table + 1472, magic_bishop_table + 2112,
  magic_bishop_table + 2400, magic_bishop_table + 2528,
  magic_bishop_table + 2592, magic_bishop_table + 2688,
  magic_bishop_table + 832, magic_bishop_table + 1216,
  magic_bishop_table + 1600, magic_bishop_table + 2240,
  magic_bishop_table + 4864, magic_bishop_table + 4960,
  magic_bishop_table + 5056, magic_bishop_table + 2720,
  magic_bishop_table + 864, magic_bishop_table + 1248,
  magic_bishop_table + 1632, magic_bishop_table + 2272,
  magic_bishop_table + 4896, magic_bishop_table + 5184
};
BITBOARD magic_rook_table[102400];
BITBOARD *magic_rook_indices[64] = {
  magic_rook_table + 86016, magic_rook_table + 73728,
  magic_rook_table + 36864, magic_rook_table + 43008,
  magic_rook_table + 47104, magic_rook_table + 51200,
  magic_rook_table + 77824, magic_rook_table + 94208,
  magic_rook_table + 69632, magic_rook_table + 32768,
  magic_rook_table + 38912, magic_rook_table + 10240,
  magic_rook_table + 14336, magic_rook_table + 53248,
  magic_rook_table + 57344, magic_rook_table + 81920,
  magic_rook_table + 24576, magic_rook_table + 33792,
  magic_rook_table + 6144, magic_rook_table + 11264,
  magic_rook_table + 15360, magic_rook_table + 18432,
  magic_rook_table + 58368, magic_rook_table + 61440,
  magic_rook_table + 26624, magic_rook_table + 4096,
  magic_rook_table + 7168, magic_rook_table + 0,
  magic_rook_table + 2048, magic_rook_table + 19456,
  magic_rook_table + 22528, magic_rook_table + 63488,
  magic_rook_table + 28672, magic_rook_table + 5120,
  magic_rook_table + 8192, magic_rook_table + 1024,
  magic_rook_table + 3072, magic_rook_table + 20480,
  magic_rook_table + 23552, magic_rook_table + 65536,
  magic_rook_table + 30720, magic_rook_table + 34816,
  magic_rook_table + 9216, magic_rook_table + 12288,
  magic_rook_table + 16384, magic_rook_table + 21504,
  magic_rook_table + 59392, magic_rook_table + 67584,
  magic_rook_table + 71680, magic_rook_table + 35840,
  magic_rook_table + 39936, magic_rook_table + 13312,
  magic_rook_table + 17408, magic_rook_table + 54272,
  magic_rook_table + 60416, magic_rook_table + 83968,
  magic_rook_table + 90112, magic_rook_table + 75776,
  magic_rook_table + 40960, magic_rook_table + 45056,
  magic_rook_table + 49152, magic_rook_table + 55296,
  magic_rook_table + 79872, magic_rook_table + 98304
};
BITBOARD magic_rook[64] = {
  0x0080001020400080ULL, 0x0040001000200040ULL, 0x0080081000200080ULL,
  0x0080040800100080ULL, 0x0080020400080080ULL, 0x0080010200040080ULL,
  0x0080008001000200ULL, 0x0080002040800100ULL, 0x0000800020400080ULL,
  0x0000400020005000ULL, 0x0000801000200080ULL, 0x0000800800100080ULL,
  0x0000800400080080ULL, 0x0000800200040080ULL, 0x0000800100020080ULL,
  0x0000800040800100ULL, 0x0000208000400080ULL, 0x0000404000201000ULL,
  0x0000808010002000ULL, 0x0000808008001000ULL, 0x0000808004000800ULL,
  0x0000808002000400ULL, 0x0000010100020004ULL, 0x0000020000408104ULL,
  0x0000208080004000ULL, 0x0000200040005000ULL, 0x0000100080200080ULL,
  0x0000080080100080ULL, 0x0000040080080080ULL, 0x0000020080040080ULL,
  0x0000010080800200ULL, 0x0000800080004100ULL, 0x0000204000800080ULL,
  0x0000200040401000ULL, 0x0000100080802000ULL, 0x0000080080801000ULL,
  0x0000040080800800ULL, 0x0000020080800400ULL, 0x0000020001010004ULL,
  0x0000800040800100ULL, 0x0000204000808000ULL, 0x0000200040008080ULL,
  0x0000100020008080ULL, 0x0000080010008080ULL, 0x0000040008008080ULL,
  0x0000020004008080ULL, 0x0000010002008080ULL, 0x0000004081020004ULL,
  0x0000204000800080ULL, 0x0000200040008080ULL, 0x0000100020008080ULL,
  0x0000080010008080ULL, 0x0000040008008080ULL, 0x0000020004008080ULL,
  0x0000800100020080ULL, 0x0000800041000080ULL, 0x00FFFCDDFCED714AULL,
  0x007FFCDDFCED714AULL, 0x003FFFCDFFD88096ULL, 0x0000040810002101ULL,
  0x0001000204080011ULL, 0x0001000204000801ULL, 0x0001000082000401ULL,
  0x0001FFFAABFAD1A2ULL
};
BITBOARD magic_rook_mask[64] = {
  0x000101010101017EULL, 0x000202020202027CULL, 0x000404040404047AULL,
  0x0008080808080876ULL, 0x001010101010106EULL, 0x002020202020205EULL,
  0x004040404040403EULL, 0x008080808080807EULL, 0x0001010101017E00ULL,
  0x0002020202027C00ULL, 0x0004040404047A00ULL, 0x0008080808087600ULL,
  0x0010101010106E00ULL, 0x0020202020205E00ULL, 0x0040404040403E00ULL,
  0x0080808080807E00ULL, 0x00010101017E0100ULL, 0x00020202027C0200ULL,
  0x00040404047A0400ULL, 0x0008080808760800ULL, 0x00101010106E1000ULL,
  0x00202020205E2000ULL, 0x00404040403E4000ULL, 0x00808080807E8000ULL,
  0x000101017E010100ULL, 0x000202027C020200ULL, 0x000404047A040400ULL,
  0x0008080876080800ULL, 0x001010106E101000ULL, 0x002020205E202000ULL,
  0x004040403E404000ULL, 0x008080807E808000ULL, 0x0001017E01010100ULL,
  0x0002027C02020200ULL, 0x0004047A04040400ULL, 0x0008087608080800ULL,
  0x0010106E10101000ULL, 0x0020205E20202000ULL, 0x0040403E40404000ULL,
  0x0080807E80808000ULL, 0x00017E0101010100ULL, 0x00027C0202020200ULL,
  0x00047A0404040400ULL, 0x0008760808080800ULL, 0x00106E1010101000ULL,
  0x00205E2020202000ULL, 0x00403E4040404000ULL, 0x00807E8080808000ULL,
  0x007E010101010100ULL, 0x007C020202020200ULL, 0x007A040404040400ULL,
  0x0076080808080800ULL, 0x006E101010101000ULL, 0x005E202020202000ULL,
  0x003E404040404000ULL, 0x007E808080808000ULL, 0x7E01010101010100ULL,
  0x7C02020202020200ULL, 0x7A04040404040400ULL, 0x7608080808080800ULL,
  0x6E10101010101000ULL, 0x5E20202020202000ULL, 0x3E40404040404000ULL,
  0x7E80808080808000ULL
};
unsigned int magic_rook_shift[64] = {
  52, 53, 53, 53, 53, 53, 53, 52,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 54, 54, 54, 54, 53,
  53, 54, 54, 53, 53, 53, 53, 53
};
BITBOARD mobility_mask_n[4] = {
  0xFF818181818181FFULL, 0x007E424242427E00ULL,
  0x00003C24243C0000ULL, 0x0000001818000000ULL
};
BITBOARD mobility_mask_b[4] = {
  0xFF818181818181FFULL, 0x007E424242427E00ULL,
  0x00003C24243C0000ULL, 0x0000001818000000ULL
};
BITBOARD mobility_mask_r[4] = {
  0x8181818181818181ULL, 0x4242424242424242ULL,
  0x2424242424242424ULL, 0x1818181818181818ULL
};
/*
  values use to deal with white/black independently
 */
const int rankflip[2][8] = {
  {RANK8, RANK7, RANK6, RANK5, RANK4, RANK3, RANK2, RANK1},
  {RANK1, RANK2, RANK3, RANK4, RANK5, RANK6, RANK7, RANK8}
};
const int sqflip[2][64] = {
  {A8, B8, C8, D8, E8, F8, G8, H8,
   A7, B7, C7, D7, E7, F7, G7, H7,
   A6, B6, C6, D6, E6, F6, G6, H6,
   A5, B5, C5, D5, E5, F5, G5, H5,
   A4, B4, C4, D4, E4, F4, G4, H4,   /* black */
   A3, B3, C3, D3, E3, F3, G3, H3,
   A2, B2, C2, D2, E2, F2, G2, H2,
   A1, B1, C1, D1, E1, F1, G1, H1},

  {A1, B1, C1, D1, E1, F1, G1, H1,
   A2, B2, C2, D2, E2, F2, G2, H2,
   A3, B3, C3, D3, E3, F3, G3, H3,
   A4, B4, C4, D4, E4, F4, G4, H4,
   A5, B5, C5, D5, E5, F5, G5, H5,   /* white */
   A6, B6, C6, D6, E6, F6, G6, H6,
   A7, B7, C7, D7, E7, F7, G7, H7,
   A8, B8, C8, D8, E8, F8, G8, H8}
};
const BITBOARD rank12[2] = { 0xffff000000000000ULL, 0x000000000000ffffULL };
const int sign[2] = { -1, 1 };
int direction[2] = { -8, 8 };
int dark_corner[2] = { FILEA, FILEH };
int light_corner[2] = { FILEH, FILEA };
int epsq[2] = { +8, -8 };
int rook_A[2] = { A8, A1 };
int rook_D[2] = { D8, D1 };
int rook_F[2] = { F8, F1 };
int rook_G[2] = { G8, G1 };
int rook_H[2] = { H8, H1 };
int pawnadv1[2] = { +8, -8 };
int pawnadv2[2] = { +16, -16 };
int capleft[2] = { +9, -7 };
int capright[2] = { +7, -9 };
const char empty_sqs[9] = { 0, '1', '2', '3', '4', '5', '6', '7', '8' };
const char square_color[64] = {
  1, 0, 1, 0, 1, 0, 1, 0,
  0, 1, 0, 1, 0, 1, 0, 1,
  1, 0, 1, 0, 1, 0, 1, 0,
  0, 1, 0, 1, 0, 1, 0, 1,
  1, 0, 1, 0, 1, 0, 1, 0,
  0, 1, 0, 1, 0, 1, 0, 1,
  1, 0, 1, 0, 1, 0, 1, 0,
  0, 1, 0, 1, 0, 1, 0, 1
};
const char b_n_mate_dark_squares[64] = {
  99, 90, 80, 70, 60, 50, 40, 30,
  90, 80, 70, 60, 50, 40, 30, 40,
  80, 70, 60, 50, 40, 30, 40, 50,
  70, 60, 50, 40, 30, 40, 50, 60,
  60, 50, 40, 30, 40, 50, 60, 70,
  50, 40, 30, 40, 50, 60, 70, 80,
  40, 30, 40, 50, 60, 70, 80, 90,
  30, 40, 50, 60, 70, 80, 90, 99
};
const char b_n_mate_light_squares[64] = {
  30, 40, 50, 60, 70, 80, 90, 99,
  40, 30, 40, 50, 60, 70, 80, 90,
  50, 40, 30, 40, 50, 60, 70, 80,
  60, 50, 40, 30, 40, 50, 60, 70,
  70, 60, 50, 40, 30, 40, 50, 60,
  80, 70, 60, 50, 40, 30, 40, 50,
  90, 80, 70, 60, 50, 40, 30, 40,
  99, 90, 80, 70, 60, 50, 40, 30
};
const int mate[64] = {
  200, 180, 160, 140, 140, 160, 180, 200,
  180, 160, 140, 120, 120, 140, 160, 180,
  160, 140, 120, 100, 100, 120, 140, 160,
  140, 120, 100, 100, 100, 100, 120, 140,
  140, 120, 100, 100, 100, 100, 120, 140,
  160, 140, 120, 100, 100, 120, 140, 160,
  180, 160, 140, 120, 120, 140, 160, 180,
  200, 180, 160, 140, 140, 160, 180, 200
};
int pc_values[7] = { 0, PAWN_VALUE, KNIGHT_VALUE,
  BISHOP_VALUE, ROOK_VALUE, QUEEN_VALUE, 0 };
extern int iterate_fail_delta[ITERATE_FAIL_DELTA] = {
  PAWN_VALUE / 8, PAWN_VALUE / 4, PAWN_VALUE / 2, PAWN_VALUE,
  KNIGHT_VALUE, ROOK_VALUE, QUEEN_VALUE, INFTY};
int MVV_LVA[7][7];
const int swap_sort_bonus[7] = { 0, 1, 3, 3, 5, 9, 0};
int piece_values[2][7] = {
  {0, -PAWN_VALUE, -KNIGHT_VALUE, -BISHOP_VALUE,
   -ROOK_VALUE, -QUEEN_VALUE, -KING_VALUE},
  {0, PAWN_VALUE, KNIGHT_VALUE, BISHOP_VALUE,
   ROOK_VALUE, QUEEN_VALUE, KING_VALUE}
};
const int total_pc_max = 14; // 4 knights + 4 bishops + 4 rooks + 2 queens
const int p_vals[7] = { 0, 1, 3, 3, 5, 9, 99 };
const int pieces[2][7] = {
  {0, -1, -2, -3, -4, -5, -6},
  {0, +1, +2, +3, +4, +5, +6}
};
int tot_mat = TOT_MAT; // 8 * p_vals[1] + 2 * p_vals[2] + 2 * p_vals[3] + 2 * p_vals[4] + p_vals[5]
int Kp = 2 * (TOT_MAT - EG_MAT); // 2 * (tot_mat - eg_mat)
//int Kp = 2 * TOT_MAT; // 2 * tot_mat
int king_value = KING_VALUE;
/*
  values used in play
 */
int pawn_value = PAWN_VALUE;
int knight_value = KNIGHT_VALUE;
int bishop_value = BISHOP_VALUE;
int rook_value = ROOK_VALUE;
int queen_value = QUEEN_VALUE;
int imbalance_minor = IMBALANCE_MINOR;
int imbalance_major = IMBALANCE_MAJOR;
int imbalance_minor_major = IMBALANCE_MINOR_MAJOR;
int imbalance_max_score = IMBALANCE_MAX_SCORE;
int bishop_pair[2] = {BISHOP_PAIR_MG, BISHOP_PAIR_EG};
int pawn_can_promote = 525;
int trousers_bonus = 8;
int eg_mat = EG_MAT;
int wtm_bonus[2] = { 5, 8 };
int lower_n = 16;
int lower_b = 10;
int lower_r = 0;
int lower_q = 0;
int mobility_score_b[2][4] = {{ 1, 2, 3, 4}, {2, 3, 4, 5}};
int mobility_score_n[4] = { 1, 2, 3, 4 };
int mobility_score_r[4] = { 1, 2, 3, 4 };
int mobility_score_q[4] = { 0, 0, 0, 0 };
int undeveloped_piece = 12;
int development_space = 0;
int friendly_queen[8] = { 0, 0, 0, 0, 0, 0, 0, 0};
int pawn_duo[2] = { 4, 8 };
int pawn_isolated[2] = { 18, 21 };
int pawn_isolated_open_file[2] = { 0, 0 };
int pawn_unsupported[2] = { 8, 4 };
int king_king_tropism = 10;
int bishop_trapped = 174;
int bishop_pawns_on_color[2]  = { 4, 6 };
int bishop_with_wing_pawns[2] = { 18, 36 };
int rook_on_7th[2] = { 25, 35 };
int connected_rook_value[2] = { 10, 5 };
/*
    each row contains values for a rook occupying a specific open
    file starting with file A and going through file H.  Row 0 is
    not used, row 1 is used when there is only one open file on
    the board, row 2 is used when there are two openfiles on the
    board, etc.  obviously control of a file is more important if
    there is only one or two files available.
*/
int rook_open_file[2] = { 35, 20 };
int rook_half_open_file[2] = { 10, 10 };
int rook_behind_passed_pawn[2][8] =
 {{ 0, 1, 1, 3,  7, 12, 20, 0 },
  { 0, 2, 2, 9, 21, 36, 60, 0 }};
int rook_trapped = 60;
int open_file[8] = { 6, 5, 4, 4, 4, 4, 5, 6 };
int half_open_file[8] = { 4, 4, 3, 3, 3, 3, 4, 4 };
int king_safety_mate_threat = 600;
int development_thematic = 12;
int development_losing_castle = 20;
int development_not_castled = 10;
int development_early_queen = 0;
int material_imbalance[9][9] = {
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
};
int king_tropism_n[8] = { 0, 3, 3, 2, 1, 0, 0, 0 };
int king_tropism_b[8] = { 0, 2, 2, 1, 0, 0, 0, 0 };
int king_tropism_r[8] = { 0, 4, 3, 2, 1, 1, 1, 1 };
int king_tropism_q[8] = { 0, 6, 5, 4, 3, 2, 2, 2 };
int passed_pawn_candidate[2][2][8] = {
 {{ 0,  0, 36, 16,  8,  4,  4, 0 },         /* [mg][black][rank] */
  { 0,  4,  4,  8, 16, 36,  0, 0 }},        /* [mg][white][rank] */
 {{ 0,  0, 48, 32, 16,  9,  9, 0 },         /* [eg][black][rank] */
  { 0,  9,  9, 16, 32, 48,  0, 0 }}         /* [eg][white][rank] */
};
int passed_pawn_value[2][2][8] = {
 {{ 0, 200, 120,  70,  30,   6,   6, 0 },   /* [mg][black][rank] */
  { 0,   6,   6,  30,  70, 120, 200, 0 }},  /* [mg][white][rank] */
 {{ 0, 220, 132,  77,  33,   7,   7, 0 },   /* [eg][black][rank] */
  { 0,   7,   7,  33,  77, 132, 220, 0 }}   /* [eg][white][rank] */
};
int connected_passed_pawn_value[2] = { 1, 3 };
int passed_pawn_hidden[2] = { 0, 40 };
int blockading_passed_pawn_value[2][2][8] = {
 {{0, 95, 57, 33, 14,  3,  3, 0},       /* [mg][black][8] */
  {0,  3,  3, 14, 33, 57, 95, 0}},      /* [mg][white][8] */
 {{0, 70, 42, 25, 11,  2,  2, 0},       /* [eg][black][8] */
  {0,  2,  2, 11, 25, 42, 70, 0}}       /* [eg][white][8] */
};
int pp_rank_bonus[8] = { 0, 1, 1, 3, 7, 12, 20, 0 };
int pp_dist_bonus[8] = { 0, 0, 0, 2, 7, 19, 31, 0 };
int doubled_pawn_value[2][8] = {
  { 5,  8,  9,  9,  9,  9,  8,  5},       /* [mg][file] */
  {17, 19, 19, 19, 19, 19, 19, 17}        /* [eg][file] */
};
int outside_passed[2] = { 20, 60 };
int pawn_defects[2][8] = {
  {0, 0, 0, 1, 2, 3, 0, 0},               /* [black][8] */
  {0, 0, 3, 2, 1, 0, 0, 0}                /* [white][8] */
};
int knight_outpost[2][64] = {
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 2, 6, 8, 8, 6, 2, 0,
    0, 1, 4, 4, 4, 4, 1, 0,   /* [black][64] */
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 2, 6, 8, 8, 6, 2, 0,   /* [white][64] */
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 }
};
int bishop_outpost[2][64] = {
  { 0, 0, 0, 0, 0, 0, 0, 0,
   -1, 0, 0, 0, 0, 0, 0,-1,
    0, 0, 1, 1, 1, 1, 0, 0,
    0, 1, 3, 3, 3, 3, 1, 0,
    0, 3, 5, 5, 5, 5, 3, 0,   /* [black][64] */
    0, 1, 2, 2, 2, 2, 1, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 2, 2, 2, 2, 1, 0,
    0, 3, 5, 5, 5, 5, 3, 0,
    0, 1, 3, 3, 3, 3, 1, 0,   /* [white][64] */
    0, 0, 1, 1, 1, 1, 0, 0,
   -1, 0, 0, 0, 0, 0, 0,-1,
    0, 0, 0, 0, 0, 0, 0, 0 }
};
int pval[2][2][64] = {
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,  10,  10,  30,  30,  10,  10,   0,
     -4,   6,   6,  16,  16,   6,   6,  -4,
     -7,   3,   3,  13,  13,   3,   3,  -7,   /* [mg][black][64] */
     -9,   1,   1,  10,  10,   1,   1,  -9,
    -10,   0,   0, -12, -12,   0,   0, -10,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
    -10,   0,   0, -12, -12,   0,   0, -10,
     -9,   1,   1,  10,  10,   1,   1,  -9,
     -7,   3,   3,  13,  13,   3,   3,  -7,
     -4,   6,   6,  16,  16,   6,   6,  -4,   /* [mg][white][64] */
      0,  10,  10,  30,  30,  10,  10,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,   0,   0,   0,   0,   0,   0,   0 }},

   {{ 0,   0,   0,   0,   0,   0,   0,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,  10,  10,  30,  30,  10,  10,   0,
     -4,   6,   6,  16,  16,   6,   6,  -4,
     -7,   3,   3,  13,  13,   3,   3,  -7,   /* [eg][black][64] */
     -9,   1,   1,  10,  10,   1,   1,  -9,
    -10,   0,   0, -12, -12,   0,   0, -10,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
    -10,   0,   0, -12, -12,   0,   0, -10,
     -9,   1,   1,  10,  10,   1,   1,  -9,
     -7,   3,   3,  13,  13,   3,   3,  -7,
     -4,   6,   6,  16,  16,   6,   6,  -4,   /* [eg][white][64] */
      0,  10,  10,  30,  30,  10,  10,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,   0,   0,   0,   0,   0,   0,   0 }}
};
int nval[2][2][64] = {
  {{-29, -19, -19,  -9,  -9, -19, -19, -29,
      1,  12,  18,  22,  22,  18,  12,   1,
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  14,  23,  28,  28,  23,  14,   1,
      1,  12,  21,  24,  24,  21,  12,   1,  /* [mg][black][64] */
      1,   2,  19,  17,  17,  19,   2,   1,
      1,   2,   2,   2,   2,   2,   2,   1,
    -19, -19, -19, -19, -19, -19, -19, -19 },
   {-19, -19, -19, -19, -19, -19, -19, -19,
      1,   2,   2,   2,   2,   2,   2,   1,
      1,   2,  19,  17,  17,  19,   2,   1,
      1,  12,  21,  24,  24,  21,  12,   1,
      1,  14,  23,  28,  28,  23,  14,   1,  /* [mg][white][64] */
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  12,  18,  22,  22,  18,  12,   1,
    -29, -19, -19,  -9,  -9, -19, -19, -29 }},
  {{-29, -19, -19,  -9,  -9, -19, -19, -29,
      1,  12,  18,  22,  22,  18,  12,   1,
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  14,  23,  28,  28,  23,  14,   1,
      1,  12,  21,  24,  24,  21,  12,   1,  /* [eg][black][64] */
      1,   2,  19,  17,  17,  19,   2,   1,
      1,   2,   2,   2,   2,   2,   2,   1,
    -19, -19, -19, -19, -19, -19, -19, -19 },
   {-19, -19, -19, -19, -19, -19, -19, -19,
      1,   2,   2,   2,   2,   2,   2,   1,
      1,   2,  19,  17,  17,  19,   2,   1,
      1,  12,  21,  24,  24,  21,  12,   1,
      1,  14,  23,  28,  28,  23,  14,   1,  /* [eg][white][64] */
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  12,  18,  22,  22,  18,  12,   1,
    -29, -19, -19,  -9,  -9, -19, -19, -29 }}
};
int bval[2][2][64] = {
  {{  0,   0,   0,   0,   0,   0,   0,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [mg][black][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
    -15, -15, -15, -15, -15, -15, -15, -15},
   {-15, -15, -15, -15, -15, -15, -15, -15,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [mg][white][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   0,   0,   0,   0,   0,   0,   0}},
  {{  0,   0,   0,   0,   0,   0,   0,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [eg][black][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
    -15, -15, -15, -15, -15, -15, -15, -15},
   {-15, -15, -15, -15, -15, -15, -15, -15,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [eg][white][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   0,   0,   0,   0,   0,   0,   0}}
};
int qval[2][2][64] = {
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [mg][black][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 },
    { 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [mg][white][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }},
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [eg][black][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 },
    { 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [eg][white][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }}
};
int kval_n[2][64] = {
   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,   /* [black][64] */
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40 },
   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,   /* [white][64] */
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40 }
};
int kval_k[2][64] = {
   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,   /* [black][64] */
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20, -20, -20, -20, -20, -20 },
   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,   /* [white][64] */
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20, -20, -20, -20, -20, -20 }
};
int kval_q[2][64] = {
   {-20, -20, -20, -20, -20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,   /* [black][64] */
     20,  20,  20,  20,  20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60 },
   {-20, -20, -20, -20, -20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
     20,  20,  20,  20,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,   /* [white][64] */
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60 }
};
int safety_vector[16] = {
   0,  7, 14, 21, 28, 35, 42,  49,
  56, 63, 70, 77, 84, 91, 98, 105
};
int tropism_vector[16] = {
   0,  1,  2,  3,   4,   5,  11,  20,
  32, 47, 65, 86, 110, 137, 167, 200
};
/*
  values not used in play
 */
int pawn_value_last = PAWN_VALUE;
int knight_value_last = KNIGHT_VALUE;
int bishop_value_last = BISHOP_VALUE;
int rook_value_last = ROOK_VALUE;
int queen_value_last = QUEEN_VALUE;
int imbalance_minor_last = IMBALANCE_MINOR;
int imbalance_major_last = IMBALANCE_MAJOR;
int imbalance_minor_major_last = IMBALANCE_MINOR_MAJOR;
int imbalance_max_score_last = IMBALANCE_MAX_SCORE;
int bishop_pair_last[2] = {BISHOP_PAIR_MG, BISHOP_PAIR_EG};
int pawn_can_promote_last = 525;
int trousers_bonus_last = 8;
int bad_trade_last = 90;
int eg_mat_last = EG_MAT;
int wtm_bonus_last[2] = { 5, 8 };
int lower_n_last = 16;
int lower_b_last = 10;
int lower_r_last = 0;
int lower_q_last = 0;
int mobility_score_b_last[2][4] = {{ 1, 2, 3, 4 }, { 2, 3, 4, 5 }};
int mobility_score_n_last[4] = { 1, 2, 3, 4 };
int mobility_score_r_last[4] = { 1, 2, 3, 4 };
int mobility_score_q_last[4] = { 0, 0, 0, 0 };
int undeveloped_piece_last = 12;
int development_space_last = 0;
int friendly_queen_last[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
int pawn_duo_last[2] = { 4, 8 };
int pawn_isolated_last[2] = { 18, 21 };
int pawn_isolated_open_file_last[2] = { 0, 0 };
int pawn_unsupported_last[2] = { 8, 4 };
int king_king_tropism_last = 10;
int bishop_trapped_last = 174;
int bishop_pawns_on_color_last[2]  = { 4, 6 };
int bishop_with_wing_pawns_last[2] = { 18, 36 };
int rook_on_7th_last[2] = { 25, 35 };
int connected_rook_value_last[2] = { 10, 5 };
/*
    each row contains values for a rook occupying a specific open
    file starting with file A and going through file H.  Row 0 is
    not used, row 1 is used when there is only one open file on
    the board, row 2 is used when there are two openfiles on the
    board, etc.  obviously control of a file is more important if
    there is only one or two files available.
*/
int rook_open_file_last[2] = { 35, 20 };
int rook_half_open_file_last[2] = { 10, 10 };
int rook_behind_passed_pawn_last[2][8] =
 {{ 0, 1, 1, 3,  7, 12, 20, 0 },
  { 0, 2, 2, 9, 21, 36, 60, 0 }};
int rook_trapped_last = 60;
int open_file_last[8] = { 6, 5, 4, 4, 4, 4, 5, 6 };
int half_open_file_last[8] = { 4, 4, 3, 3, 3, 3, 4, 4 };
int king_safety_mate_threat_last = 600;
int development_thematic_last = 12;
int development_losing_castle_last = 20;
int development_not_castled_last = 10;
int development_early_queen_last = 0;
int material_imbalance_last[9][9] = {
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
  {0, 0, 0, 0, 0, 0, 0, 0, 0},
};
int king_tropism_n_last[8] = { 0, 3, 3, 2, 1, 0, 0, 0 };
int king_tropism_b_last[8] = { 0, 2, 2, 1, 0, 0, 0, 0 };
int king_tropism_r_last[8] = { 0, 4, 3, 2, 1, 1, 1, 1 };
int king_tropism_q_last[8] = { 0, 6, 5, 4, 3, 2, 2, 2 };
int passed_pawn_candidate_last[2][2][8] = {
 {{ 0,  0, 36, 16,  8,  4,  4, 0 },         /* [mg][black][rank] */
  { 0,  4,  4,  8, 16, 36,  0, 0 }},        /* [mg][white][rank] */
 {{ 0,  0, 48, 32, 16,  9,  9, 0 },         /* [eg][black][rank] */
  { 0,  9,  9, 16, 32, 48,  0, 0 }}         /* [eg][white][rank] */
};
int passed_pawn_value_last[2][2][8] = {
 {{ 0, 200, 120,  70,  30,   6,   6, 0 },   /* [mg][black][rank] */
  { 0,   6,   6,  30,  70, 120, 200, 0 }},  /* [mg][white][rank] */
 {{ 0, 220, 132,  77,  33,   7,   7, 0 },   /* [eg][black][rank] */
  { 0,   7,   7,  33,  77, 132, 220, 0 }}   /* [eg][white][rank] */
};
int connected_passed_pawn_value_last[2] = { 1, 3 };
int passed_pawn_hidden_last[2] = { 0, 40 };
int blockading_passed_pawn_value_last[2][2][8] = {
 {{0, 95, 57, 33, 14,  3,  3, 0},       /* [mg][black][8] */
  {0,  3,  3, 14, 33, 57, 95, 0}},      /* [mg][white][8] */
 {{0, 70, 42, 25, 11,  2,  2, 0},       /* [eg][black][8] */
  {0,  2,  2, 11, 25, 42, 70, 0}}       /* [eg][white][8] */
};
int pp_rank_bonus_last[8] = { 0, 1, 1, 3, 7, 12, 20, 0 };
int pp_dist_bonus_last[8] = { 0, 0, 0, 2, 7, 19, 31, 0 };
int doubled_pawn_value_last[2][8] = {
  { 5,  8,  9,  9,  9,  9,  8,  5},       /* [mg][file] */
  {17, 19, 19, 19, 19, 19, 19, 17}        /* [eg][file] */
};
int outside_passed_last[2] = { 20, 60 };
int pawn_defects_last[2][8] = {
  {0, 0, 0, 1, 2, 3, 0, 0},               /* [black][8] */
  {0, 0, 3, 2, 1, 0, 0, 0}                /* [white][8] */
};
int knight_outpost_last[2][64] = {
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 2, 6, 8, 8, 6, 2, 0,
    0, 1, 4, 4, 4, 4, 1, 0,   /* [black][64] */
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 2, 6, 8, 8, 6, 2, 0,   /* [white][64] */
    0, 1, 4, 4, 4, 4, 1, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 }
};
int bishop_outpost_last[2][64] = {
  { 0, 0, 0, 0, 0, 0, 0, 0,
   -1, 0, 0, 0, 0, 0, 0,-1,
    0, 0, 1, 1, 1, 1, 0, 0,
    0, 1, 3, 3, 3, 3, 1, 0,
    0, 3, 5, 5, 5, 5, 3, 0,   /* [black][64] */
    0, 1, 2, 2, 2, 2, 1, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0 },
  { 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0,
    0, 1, 2, 2, 2, 2, 1, 0,
    0, 3, 5, 5, 5, 5, 3, 0,
    0, 1, 3, 3, 3, 3, 1, 0,   /* [white][64] */
    0, 0, 1, 1, 1, 1, 0, 0,
   -1, 0, 0, 0, 0, 0, 0,-1,
    0, 0, 0, 0, 0, 0, 0, 0 }
};
int pval_last[2][2][64] = {
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,  10,  10,  30,  30,  10,  10,   0,
     -4,   6,   6,  16,  16,   6,   6,  -4,
     -7,   3,   3,  13,  13,   3,   3,  -7,   /* [mg][black][64] */
     -9,   1,   1,  10,  10,   1,   1,  -9,
    -10,   0,   0, -12, -12,   0,   0, -10,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
    -10,   0,   0, -12, -12,   0,   0, -10,
     -9,   1,   1,  10,  10,   1,   1,  -9,
     -7,   3,   3,  13,  13,   3,   3,  -7,
     -4,   6,   6,  16,  16,   6,   6,  -4,   /* [mg][white][64] */
      0,  10,  10,  30,  30,  10,  10,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,   0,   0,   0,   0,   0,   0,   0 }},

   {{ 0,   0,   0,   0,   0,   0,   0,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,  10,  10,  30,  30,  10,  10,   0,
     -4,   6,   6,  16,  16,   6,   6,  -4,
     -7,   3,   3,  13,  13,   3,   3,  -7,   /* [eg][black][64] */
     -9,   1,   1,  10,  10,   1,   1,  -9,
    -10,   0,   0, -12, -12,   0,   0, -10,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
    -10,   0,   0, -12, -12,   0,   0, -10,
     -9,   1,   1,  10,  10,   1,   1,  -9,
     -7,   3,   3,  13,  13,   3,   3,  -7,
     -4,   6,   6,  16,  16,   6,   6,  -4,   /* [eg][white][64] */
      0,  10,  10,  30,  30,  10,  10,   0,
     56,  66,  66,  66,  66,  66,  66,  56,
      0,   0,   0,   0,   0,   0,   0,   0 }}
};
int nval_last[2][2][64] = {
  {{-29, -19, -19,  -9,  -9, -19, -19, -29,
      1,  12,  18,  22,  22,  18,  12,   1,
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  14,  23,  28,  28,  23,  14,   1,
      1,  12,  21,  24,  24,  21,  12,   1,  /* [mg][black][64] */
      1,   2,  19,  17,  17,  19,   2,   1,
      1,   2,   2,   2,   2,   2,   2,   1,
    -19, -19, -19, -19, -19, -19, -19, -19 },
   {-19, -19, -19, -19, -19, -19, -19, -19,
      1,   2,   2,   2,   2,   2,   2,   1,
      1,   2,  19,  17,  17,  19,   2,   1,
      1,  12,  21,  24,  24,  21,  12,   1,
      1,  14,  23,  28,  28,  23,  14,   1,  /* [mg][white][64] */
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  12,  18,  22,  22,  18,  12,   1,
    -29, -19, -19,  -9,  -9, -19, -19, -29 }},
  {{-29, -19, -19,  -9,  -9, -19, -19, -29,
      1,  12,  18,  22,  22,  18,  12,   1,
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  14,  23,  28,  28,  23,  14,   1,
      1,  12,  21,  24,  24,  21,  12,   1,  /* [eg][black][64] */
      1,   2,  19,  17,  17,  19,   2,   1,
      1,   2,   2,   2,   2,   2,   2,   1,
    -19, -19, -19, -19, -19, -19, -19, -19 },
   {-19, -19, -19, -19, -19, -19, -19, -19,
      1,   2,   2,   2,   2,   2,   2,   1,
      1,   2,  19,  17,  17,  19,   2,   1,
      1,  12,  21,  24,  24,  21,  12,   1,
      1,  14,  23,  28,  28,  23,  14,   1,  /* [eg][white][64] */
      1,  14,  23,  27,  27,  23,  14,   1,
      1,  12,  18,  22,  22,  18,  12,   1,
    -29, -19, -19,  -9,  -9, -19, -19, -29 }}
};
int bval_last[2][2][64] = {
  {{  0,   0,   0,   0,   0,   0,   0,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [mg][black][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
    -15, -15, -15, -15, -15, -15, -15, -15},
   {-15, -15, -15, -15, -15, -15, -15, -15,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [mg][white][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   0,   0,   0,   0,   0,   0,   0}},
  {{  0,   0,   0,   0,   0,   0,   0,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [eg][black][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
    -15, -15, -15, -15, -15, -15, -15, -15},
   {-15, -15, -15, -15, -15, -15, -15, -15,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,
      0,   4,   8,  12,  12,   8,   4,   0,  /* [eg][white][64] */
      0,   4,   8,   8,   8,   8,   4,   0,
      0,   4,   4,   4,   4,   4,   4,   0,
      0,   0,   0,   0,   0,   0,   0,   0}}
};
int qval_last[2][2][64] = {
   {{ 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [mg][black][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [mg][white][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }},

   {{ 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [eg][black][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 },

    { 0,   0,   0,   0,   0,   0,   0,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,
      0,   4,   6,   8,   8,   6,   4,   0,   /* [eg][white][64] */
      0,   4,   4,   6,   6,   4,   4,   0,
      0,   0,   4,   4,   4,   4,   0,   0,
      0,   0,   0,   0,   0,   0,   0,   0 }}
};
int kval_n_last[2][64] = {
   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,   /* [black][64] */
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40 },
   {-40, -40, -40, -40, -40, -40, -40, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -10,  20,  20,  20,  20, -10, -40,
    -40, -10,  40,  40,  40,  40, -10, -40,
    -40, -10,  60,  60,  60,  60, -10, -40,   /* [white][64] */
    -40, -10,  60,  60,  60,  60, -10, -40,
    -40, -10, -10, -10, -10, -10, -10, -40,
    -40, -40, -40, -40, -40, -40, -40, -40 }
};
int kval_k_last[2][64] = {
   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,   /* [black][64] */
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20, -20, -20, -20, -20, -20 },
   {-60, -40, -20, -20, -20, -20, -20, -20,
    -60, -40, -20,   0,   0,   0,   0,   0,
    -60, -40, -20,  20,  20,  20,  20,  20,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20,  20,  60,  60,  60,  40,   /* [white][64] */
    -60, -40, -20,  20,  60,  60,  60,  40,
    -60, -40, -20,  20,  40,  40,  40,  40,
    -60, -40, -20, -20, -20, -20, -20, -20 }
};
int kval_q_last[2][64] = {
   {-20, -20, -20, -20, -20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,   /* [black][64] */
     20,  20,  20,  20,  20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60 },
   {-20, -20, -20, -20, -20, -20, -40, -60,
      0,   0,   0,   0,   0, -20, -40, -60,
     20,  20,  20,  20,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
     40,  60,  60,  60,  20, -20, -40, -60,   /* [white][64] */
     40,  60,  60,  60,  20, -20, -40, -60,
     40,  40,  40,  40,  20, -20, -40, -60,
    -20, -20, -20, -20, -20, -20, -40, -60 }
};
int safety_vector_last[16] = {
   0,  7, 14, 21, 28, 35, 42,  49,
  56, 63, 70, 77, 84, 91, 98, 105
};
int tropism_vector_last[16] = {
   0,  1,  2,  3,   4,   5,  11,  20,
  32, 47, 65, 86, 110, 137, 167, 200
};
/*
   First term is a character string explaining what the personality
   term is used for.

  Second term is the "type" of the value.
     0 = heading entry (no values, just a category name to display).
     1 = scalar value.
     2 = mg/eg two-element array
     3 = array[mg][side][64].  These values are displayed as 8x8
       boards with white values at the bottom, and the ranks/files
       labeled to make them easier to read.
     4 = array[side][64]
     5 = array[side][N!=64]
     6 = array[mg][side][8]
     7 = array[mg][small#]
     8 = array[n]
     9 = array[n][n]

   Third term is the "size" of the scoring term, where 0 is a
     scalar value, otherwise it is the actual number of elements in
     an array of values.

   Fourth term is a pointer to the data value(s).

   Fifth term is a pointer to the data value(s) last.

   Sixth term is the "category" of the the personality term.
*/
struct personality_term personality_packet[256] = {
  {"search options                               ", 0, 0, NULL, NULL, 0},      /* 0 */
  {"aspiration window -m-                        ", 1, 0, &aspiration_window, &aspiration_window_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"null-move reduction [bound] -m- -a-          ", 9, 2, reduce_null_depth, reduce_null_depth_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"FP depth -m-                                 ", 1, 0, &pruning_depth, &pruning_depth_last, CATEGORY_SEARCH},
  {"FP margin [depth] -m-                        ", 8, 8, pruning_margin, pruning_margin_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"LMP depth -m-                                ", 1, 0, &movecnt_depth, &movecnt_depth_last, CATEGORY_SEARCH},
  {"LMP move count [depth] -m-                   ", 8, 8, movecnt_margin, movecnt_margin_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"LMR min distance to frontier [bound] -m- -a- ", 9, 2, LMR_min_depth, LMR_min_depth_last, CATEGORY_SEARCH},
  {"LMR max plies -m- -a-                        ", 1, 0, &LMR_max_plies, &LMR_max_plies_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"LMR scale -m-                                ", 1, 0, &lmr_scale, &lmr_scale_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"forward pruning proportion [type] -m-        ", 8, 8, pruning_proportion, pruning_proportion_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"other reduction [bound] -m- -a-              ", 9, 2, reduce_depth, reduce_depth_last, CATEGORY_SEARCH},
  {"history max moves -m-                        ", 1, 0, &history_max_moves, &history_max_moves_last, CATEGORY_SEARCH},
  {"search extensions [extension] -m- -a-        ", 8, 16, extension_depth, extension_depth_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"SE margin -m-                                ", 1, 0, &singular_extension_margin, &singular_extension_margin_last, CATEGORY_SEARCH},
  {"ProbCut margin -m-                           ", 1, 0, &probcut_margin, &probcut_margin_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {"quiescent check depth -m- -a-                ", 1, 0, &quiesce_check_depth, &quiesce_check_depth_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"late moves margin -m-                        ", 1, 0, &late_moves_margin, &late_moves_margin_last, CATEGORY_SEARCH},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"pruning search flags -m- -a-                 ", 1, 0, &search_pruning_flags, &search_pruning_flags_last, CATEGORY_SEARCH},
  {"quiescent search flags -m- -a-               ", 1, 0, &search_quiescent_flags, &search_quiescent_flags_last, CATEGORY_SEARCH},
  {"search flags -m- -a-                         ", 1, 0, &search_flags, &search_flags_last, CATEGORY_SEARCH},
  {"material scoring                             ", 0, 0, NULL, NULL, 0},      /* 40 */
  {"pawn value -m-                               ", 1, 0, &pawn_value, &pawn_value_last, CATEGORY_MATERIAL},
  {"knight value -m-                             ", 1, 0, &knight_value, &knight_value_last, CATEGORY_MATERIAL},
  {"bishop value -m-                             ", 1, 0, &bishop_value, &bishop_value_last, CATEGORY_MATERIAL},
  {"rook value -m-                               ", 1, 0, &rook_value, &rook_value_last, CATEGORY_MATERIAL},
  {"queen value -m-                              ", 1, 0, &queen_value, &queen_value_last, CATEGORY_MATERIAL},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                 /* 50 */
  {"imbalance minor down -m-                     ", 1, 0, &imbalance_minor, &imbalance_minor_last, CATEGORY_MATERIAL},
  {"imbalance major down -m-                     ", 1, 0, &imbalance_major, &imbalance_major_last, CATEGORY_MATERIAL},
  {"imbalance minor vs major -m-                 ", 1, 0, &imbalance_minor_major, &imbalance_minor_major_last, CATEGORY_MATERIAL},
  {"imbalance max score -m-                      ", 1, 0, &imbalance_max_score, &imbalance_max_score_last, CATEGORY_MATERIAL},
  {"bishop pair [phase] -m-                      ", 2, 2, bishop_pair, bishop_pair_last, CATEGORY_MATERIAL},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"other scoring values                         ", 0, 0, NULL, NULL},         /* 60 */
  {"tempo bonus [phase]                          ", 2, 2, wtm_bonus, wtm_bonus_last, CATEGORY_OTHER},
  {"draw score -m-                               ", 1, 0, &abs_draw_score, &abs_draw_score_last, CATEGORY_OTHER},
  {"lazy evaluation cutoff [bound] -m-           ", 9, 2, lazy_eval_cutoff, lazy_eval_cutoff_last, CATEGORY_OTHER},
  {"endgame material                             ", 1, 0, &eg_mat, &eg_mat_last, CATEGORY_OTHER},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"pawn scoring                                 ", 0, 0, NULL, NULL, 0},      /* 70 */
  {"pawn square table [phase][side][square]      ", 3, 256, (int *)pval, (int *)pval_last, CATEGORY_PAWN | CATEGORY_SQUARE},
  {"connected passed pawn [phase]                ", 2, 2, connected_passed_pawn_value, connected_passed_pawn_value_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN | CATEGORY_STRATEGY},
  {"passed pawn candidate [phase][side][rank]    ", 6, 32, (int *)passed_pawn_candidate, (int *)passed_pawn_candidate_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN | CATEGORY_STRATEGY},
  {"passed pawn [phase][side][rank]              ", 6, 32, (int *)passed_pawn_value, (int *)passed_pawn_value_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN | CATEGORY_STRATEGY},
  {"blockading a passed pawn [phase][side][rank] ", 6, 32, (int *)blockading_passed_pawn_value, (int *)blockading_passed_pawn_value_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN},
  {"passed pawn rank bonus [rank]                ", 8, 8, (int *)pp_rank_bonus, (int *)pp_rank_bonus_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN},
  {"passed pawn distance bonus [rank]            ", 8, 8, (int *)pp_dist_bonus, (int *)pp_dist_bonus_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN},
  {"pawn duo [phase]                             ", 2, 2, pawn_duo, pawn_duo_last, CATEGORY_PAWN},
  {"pawn isolated [phase]                        ", 2, 2, pawn_isolated, pawn_isolated_last, CATEGORY_PAWN | CATEGORY_STRATEGY},
  {NULL, 0, 0, NULL, NULL, 0},
  {"pawn can promote                             ", 1, 0, &pawn_can_promote, &pawn_can_promote_last, CATEGORY_PAWN},
  {"outside passed pawn [phase]                  ", 2, 2, outside_passed, outside_passed_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN | CATEGORY_STRATEGY},
  {"hidden passed pawn [phase]                   ", 2, 2, passed_pawn_hidden, passed_pawn_hidden_last, CATEGORY_PAWN | CATEGORY_PASSED_PAWN | CATEGORY_STRATEGY},
  {"doubled pawn [phase][file]                   ", 6, 16, (int *)doubled_pawn_value, (int *)doubled_pawn_value_last, CATEGORY_PAWN | CATEGORY_STRATEGY},
  {"pawn isolated open file [phase]              ", 2, 2, pawn_isolated_open_file, pawn_isolated_open_file_last, CATEGORY_PAWN | CATEGORY_STRATEGY},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"pawn unsupported [phase]                     ", 2, 2, pawn_unsupported, pawn_unsupported_last, CATEGORY_PAWN | CATEGORY_STRATEGY},
  {"trousers bonus                               ", 1, 0, &trousers_bonus, &trousers_bonus_last, CATEGORY_PAWN},
  {"knight scoring                               ", 0, 0, NULL, NULL, 0},      /* 90 */
  {"knight square table [phase][side][square]    ", 3, 256, (int *)nval, (int *)nval_last, CATEGORY_KNIGHT | CATEGORY_SQUARE | CATEGORY_TACTICS},
  {"knight outpost [side][square]                ", 4, 128, (int *)knight_outpost, (int *)knight_outpost_last, CATEGORY_KNIGHT | CATEGORY_STRATEGY},
  {"knight king tropism [distance]               ", 8, 8, king_tropism_n, king_tropism_n_last, CATEGORY_KNIGHT | CATEGORY_TACTICS},
  {"knight mobility [part]                       ", 8, 4, mobility_score_n, mobility_score_n_last, CATEGORY_KNIGHT | CATEGORY_MOBILITY | CATEGORY_TACTICS},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"bishop scoring                               ", 0, 0, NULL, NULL, 0},      /* 100 */
  {"bishop square table [phase][side][square]    ", 3, 256, (int *)bval, (int *)bval_last, CATEGORY_BISHOP | CATEGORY_SQUARE | CATEGORY_TACTICS},
  {"bishop outpost [phase][square]               ", 4, 128, (int *)bishop_outpost, (int *)bishop_outpost_last, CATEGORY_BISHOP | CATEGORY_STRATEGY},
  {"bishop king tropism [distance]               ", 8, 8, king_tropism_b, king_tropism_b_last, CATEGORY_BISHOP | CATEGORY_TACTICS},
  {"bishop mobility [pair][part]                 ", 8, 8, (int *)mobility_score_b, (int *)mobility_score_b_last, CATEGORY_BISHOP | CATEGORY_MOBILITY | CATEGORY_TACTICS},
  {"bishop pawns on colour [phase]               ", 2, 2, bishop_pawns_on_color, bishop_pawns_on_color_last, CATEGORY_BISHOP},
  {"bishop with wing pawns [phase]               ", 2, 2, bishop_with_wing_pawns, bishop_with_wing_pawns_last, CATEGORY_BISHOP},
  {"bishop trapped                               ", 1, 0, &bishop_trapped, &bishop_trapped_last, CATEGORY_BISHOP},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"rook scoring                                 ", 0, 0, NULL, NULL, 0},      /* 110 */
  {"rook open file [phase]                       ", 2, 2, rook_open_file, rook_open_file_last, CATEGORY_ROOK | CATEGORY_STRATEGY},
  {"rook king tropism [distance]                 ", 8, 8, king_tropism_r, king_tropism_r_last, CATEGORY_ROOK | CATEGORY_TACTICS},
  {"rook mobility [part]                         ", 8, 4, mobility_score_r, mobility_score_r_last, CATEGORY_ROOK | CATEGORY_MOBILITY | CATEGORY_TACTICS},
  {"rook half open file [phase]                  ", 2, 2, rook_half_open_file, rook_half_open_file_last, CATEGORY_ROOK  | CATEGORY_STRATEGY},
  {"rook on 7th [phase]                          ", 2, 2, rook_on_7th, rook_on_7th_last, CATEGORY_ROOK},
  {"rook behind passed pawn [phase][rank]        ", 6, 16, (int *)rook_behind_passed_pawn, (int *)rook_behind_passed_pawn_last, CATEGORY_ROOK | CATEGORY_PASSED_PAWN},
  {"rook trapped                                 ", 1, 0, &rook_trapped, &rook_trapped_last, CATEGORY_ROOK},
  {"rook mobility curve [score]                  ", 2, 48, mob_curve_r, mob_curve_r_last, CATEGORY_ROOK | CATEGORY_MOBILITY | CATEGORY_TACTICS},
  {"connected rook [phase]                       ", 2, 2, connected_rook_value, connected_rook_value_last, CATEGORY_ROOK},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"queen scoring                                ", 0, 0, NULL, NULL, 0},     /* 130 */
  {"queen square table [phase][side][square]     ", 3, 256, (int *)qval, (int *)qval_last, CATEGORY_QUEEN | CATEGORY_SQUARE | CATEGORY_TACTICS},
  {"queen king tropism [distance]                ", 8, 8, king_tropism_q, king_tropism_q_last, CATEGORY_QUEEN | CATEGORY_TACTICS},
  {"friendly queen king tropism [distance]       ", 8, 8, friendly_queen, friendly_queen_last, CATEGORY_QUEEN | CATEGORY_TACTICS},
  {"queen mobility [part]                        ", 8, 4, mobility_score_q, mobility_score_q_last, CATEGORY_QUEEN | CATEGORY_MOBILITY | CATEGORY_TACTICS},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"king scoring                                 ", 0, 0, NULL, NULL, 0},     /* 140 */
  {"king square table normal [side][square]      ", 4, 128, (int *)kval_n, (int *)kval_n_last, CATEGORY_KING | CATEGORY_SQUARE | CATEGORY_TACTICS},
  {"king square table kside pawns [side][square] ", 4, 128, (int *)kval_k, (int *)kval_k_last, CATEGORY_KING | CATEGORY_SQUARE},
  {"king square table qside pawns [side][square] ", 4, 128, (int *)kval_q, (int *)kval_q_last, CATEGORY_KING | CATEGORY_SQUARE},
  {"king safety pawn defects [side][rank] -m-    ", 5, 16, (int *)pawn_defects, (int *)pawn_defects_last, CATEGORY_KING},
  {"king safe open file [file] -m-               ", 8, 8, open_file, open_file_last, CATEGORY_KING},
  {"king safe half-open file [file] -m-          ", 8, 8, half_open_file, half_open_file_last, CATEGORY_KING},
  {"king safety vector [safety]                  ", 2, 16, (int *)safety_vector, (int *)safety_vector_last, CATEGORY_KING},
  {"king tropism vector [tropism]                ", 2, 16, (int *)tropism_vector, (int *)tropism_vector_last, CATEGORY_KING},
  {"king safety scale                            ", 1, 0, &king_safety_scale, &king_safety_scale_last, CATEGORY_KING},
  {"king king tropism (endgame)                  ", 1, 0, &king_king_tropism, &king_king_tropism_last, CATEGORY_KING},
  {"king safety trojan horse threat              ", 1, 0, &king_safety_mate_threat, &king_safety_mate_threat_last, CATEGORY_KING},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {"development scoring                          ", 0, 0, NULL, NULL, 0},     /* 160 */
  {"development thematic                         ", 1, 0, &development_thematic, &development_thematic_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {"development losing castle rights             ", 1, 0, &development_losing_castle, &development_losing_castle_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {"development not castled                      ", 1, 0, &development_not_castled, &development_not_castled_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {"development undeveloped piece                ", 1, 0, &undeveloped_piece, &undeveloped_piece_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {"development space                            ", 1, 0, &development_space, &development_space_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {"development early queen                      ", 1, 0, &development_early_queen, &development_early_queen_last, CATEGORY_DEVELOPMENT | CATEGORY_STRATEGY},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 170 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 180 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 190 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 200 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 210 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 220 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 230 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 240 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},                                                /* 250 */
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0},
  {NULL, 0, 0, NULL, NULL, 0}                                                 /* 255 */
};


