#if !defined(DATA_INCLUDED)
#  define DATA_INCLUDED
#if defined(_WIN32) || defined(_WIN64)
extern char version[64];
#else
char version[];
#endif
extern PLAYING_MODE mode;
extern int batch_mode;
extern int swindle_mode;
extern int call_flag;
extern int crafty_rating;
extern int opponent_rating;
extern int time_used;
extern int time_used_opponent;
extern UINT64 total_moves;
extern int initialized;
extern int early_exit;
extern int test_running;
extern BITBOARD test_score_diff;
extern int test_score_threshold;
extern int new_game;
extern char *AK_list[128];
extern char *GM_list[128];
extern char *IM_list[128];
extern char *C_list[128];
extern char *B_list[128];
extern char *SP_list[128];
extern char *SP_opening_filename[128];
extern char *SP_personality_filename[128];
extern char personality_comment[128];
extern FILE *input_stream;
extern FILE *dbout;
extern FILE *book_file;
extern FILE *books_file;
extern FILE *normal_bs_file;
extern FILE *computer_bs_file;
extern FILE *history_file;
extern FILE *log_file;
extern FILE *eval_file;
extern FILE *eval_tex_file;
extern FILE *eval_ctl_file;
extern int tex_cnt;
extern int log_id;
extern int log_trace;
extern int output_format;
#  if !defined(NOEGTB)
extern int EGTBlimit;
extern int EGTB_draw;
extern int EGTB_search;
extern int EGTB_use;
extern void *EGTB_cache;
extern size_t EGTB_cache_size;
extern int EGTB_setup;
#  endif
extern int NNUE_setup;
extern int done;
extern int last_mate_score;
extern int last_opponent_move;
extern int search_pruning_flags;
extern int search_pruning_flags_last;
extern int search_quiescent_flags;
extern int search_quiescent_flags_last;
extern int search_flags;
extern int search_flags_last;
extern int extension_depth[16];
extern int extension_depth_last[16];
extern int quiesce_check_depth;
extern int quiesce_check_depth_last;
extern int reduce_null_depth[2];
extern int reduce_null_depth_last[2];
extern int reduce_depth[2];
extern int reduce_depth_last[2];
extern int LMR_min_depth[2];
extern int LMR_min_depth_last[2];
extern int LMR_max_plies;
extern int LMR_max_plies_last;
extern int lmr_max_plies;
extern int reductions[2][2][32][64];
extern int popcnt64;
extern int aspiration_window;
extern int aspiration_window_last;
extern int pgn_suggested_percent;
extern char pgn_event[128];
extern char pgn_date[128];
extern char pgn_round[128];
extern char pgn_site[128];
extern char pgn_white[128];
extern char pgn_white_elo[128];
extern char pgn_black[128];
extern char pgn_black_elo[128];
extern char pgn_result[128];
extern char log_filename[256];
extern char history_filename[256];
extern char book_filename[256];
extern char books_filename[256];
extern char bookc_filename[256];
extern int number_of_solutions;
extern int solutions[10];
extern int solution_type;
extern int abs_draw_score;
extern int abs_draw_score_last;
extern int accept_draws;
extern int offer_draws;
extern int adaptive_hash;
extern size_t adaptive_hash_min;
extern size_t adaptive_hash_max;
extern size_t adaptive_hashp_min;
extern size_t adaptive_hashp_max;
extern int over;
extern int silent;
extern int ics;
extern int xboard;
extern int pong;
extern int channel;
extern char channel_title[32];
extern char personality[64];
extern char personality_last[64];
extern char book_path[128];
extern char log_path[128];
extern char tb_path[128];
extern char nnue_file[128];
extern char rc_path[128];
extern char cmd_buffer[4096];
extern char *args[512];
extern char buffer[4096];
extern int line_length;
extern unsigned char convert_buff[8];
extern int nargs;
extern int kibitz;
extern int wtm;
extern int last_search_value;
extern int lazy_eval_cutoff[2];
extern int lazy_eval_cutoff_last[2];
extern int pruning_depth;
extern int pruning_depth_last;
extern int movecnt_depth;
extern int movecnt_depth_last;
extern int singular_extension_margin;
extern int singular_extension_margin_last;
extern int probcut_margin;
extern int probcut_margin_last;
extern int late_moves_margin;
extern int late_moves_margin_last;
extern int lmr_scale;
extern int lmr_scale_last;
extern int history_max_moves;
extern int history_max_moves_last;
extern int king_safety_scale;
extern int king_safety_scale_last;
extern int pruning_margin[8];
extern int pruning_margin_last[8];
extern int pruning_proportion[8];
extern int pruning_proportion_last[8];
extern int movecnt_margin[8];
extern int movecnt_margin_last[8];
extern int singular_depth;
extern int singular_depth_last;
extern int singular_ext_margin;
extern int singular_ext_margin_last;
extern int quiesce_futility_margin;
extern int quiesce_futility_margin_last;
extern int ponder_value;
extern int move_actually_played;
extern int analyze_mode;
extern int annotate_mode;
extern int input_status;        /* 0=no input;
                                   1=predicted move read;
                                   2=unpredicted move read;
                                   3=something read, not executed. */
extern int resign;
extern int computer_resign;
extern int resign_counter;
extern int resign_count;
extern int draw_counter;
extern int draw_count;
extern int draw_offer_pending;
extern int draw_offered;
extern char audible_alarm;
extern char speech;
extern char hint[512];
extern char book_hint[512];
extern int post;
extern int search_depth;
#if defined(_WIN32) || defined(_WIN64)
HANDLE timer_handle_search;
#endif
extern unsigned int search_nodes;
extern unsigned int temp_search_nodes;
extern int search_move;
extern int ponder;
extern int ponder_move;
extern int force;
extern int ponder_moves[220];
extern int num_ponder_moves;
extern char initial_position[80];
extern int predicted;
extern int ansi;
extern int trace_level;
extern int book_move;
extern int book_accept_mask;
extern int book_reject_mask;
extern int book_random;
extern float book_weight_freq;
extern float book_weight_eval;
extern float book_weight_learn;
extern int book_search_trigger;
extern int book_selection_width;
extern int computer_book_selection_width;
extern int show_book;
extern int learning;
extern int time_abort;
extern int abort_search;
extern int iteration_depth;
extern int maximum_ply;
extern int root_alpha;
extern int root_beta;
extern int root_value;
extern int root_wtm;
extern int last_root_value;
extern ROOT_MOVE root_moves[256];
extern int n_root_moves;
extern int best_root_capture;
extern int root_material_evaluation;
extern int difficulty;
extern int time_limit;
extern int absolute_time_limit;
extern int search_time_limit;
extern int burp;
extern volatile int quit;
extern unsigned int opponent_start_time, opponent_end_time;
extern unsigned int program_start_time, program_end_time;
extern unsigned int start_time, end_time;
extern unsigned int elapsed_start, elapsed_end;
extern unsigned int program_start_cpu_time, program_end_cpu_time;
extern TREE *block[MAX_BLOCKS + 1];
extern TREE *volatile thread[CPUS];
#  if (CPUS > 1)
extern lock_t lock_smp, lock_io, lock_root, lock_his;
#if defined(UNIX)
  extern pthread_attr_t attributes;
#endif
#  endif
extern unsigned int parallel_splits;
extern unsigned int parallel_aborts;
extern unsigned int max_split_blocks;
extern volatile int smp_idle;
extern volatile int smp_threads;
extern volatile int initialized_threads;
extern int crafty_is_white;
extern int average_nps;
extern unsigned int nodes_per_second;
extern int time_check;
extern int transposition_age;
extern int thinking;
extern int pondering;
extern int puzzling;
extern int booking;
extern int trojan_check;
extern int computer_opponent;
extern int display_options;
extern int dont_log;
extern int smp_max_threads;
extern int max_thread_group;
extern int split_at_root;
extern unsigned int noise_level;
extern int tc_moves;
extern int tc_time;
extern int tc_time_remaining[2];
extern int tc_moves_remaining[2];
extern int tc_secondary_moves;
extern int tc_secondary_time;
extern int tc_increment;
extern int tc_sudden_death;
extern int tc_operator_time;
extern int tc_safety_margin;
extern int draw_score[2];
extern char kibitz_text[512];
extern int kibitz_iteration_depth;
extern int kibitz_maximum_ply;
extern int kibitz_iteration_depth_last;
extern int kibitz_maximum_ply_last;
extern int kibitz_maximum_ply_last_last;
extern int move_number;
extern int root_print_ok;
extern int moves_out_of_book;
extern int first_nonbook_factor;
extern int first_nonbook_span;
extern int smp_nice;

#  if defined(SKILL)
extern int skill;
#  endif
extern int book_learn_eval[LEARN_INTERVAL];
extern int book_learn_depth[LEARN_INTERVAL];
extern int learn_seekto[64];
extern UINT64 learn_key[64];
extern int learn_nmoves[64];
extern UINT64 book_learn_key;
extern int learn_positions_count;
extern int book_learn_nmoves;
extern int book_learn_seekto;
extern int usage_level;
extern int log_hash;
extern int log_pawn_hash;
extern size_t hash_table_size;
extern size_t hash_path_size;
extern UINT64 hash_path_mask;
extern size_t pawn_hash_table_size;
extern UINT64 hash_mask;
extern UINT64 pawn_hash_mask;
extern HASH_ENTRY *trans_ref;
extern HPATH_ENTRY *hash_path;
extern PAWN_HASH_ENTRY *pawn_hash_table;
extern void *segments[MAX_BLOCKS + 32][2];
extern int nsegments;
extern size_t cb_trans_ref;
extern size_t cb_pawn_hash_table;
extern UINT64 eval_hash_mask;
extern int pc_values[7];
extern int iterate_fail_delta[ITERATE_FAIL_DELTA];
extern int MVV_LVA[7][7];
extern const int swap_sort_bonus[7];
extern const int total_pc_max;
extern const int p_vals[7];
extern const int pieces[2][7];
extern PATH last_pv;
extern int last_value;
extern const char translate[13];
extern const char empty_sqs[9];
extern const char square_color[64];
extern int knight_outpost[2][64];
extern int knight_outpost_last[2][64];
extern int bishop_outpost[2][64];
extern int bishop_outpost_last[2][64];
extern int passed_pawn_value[2][2][8];
extern int passed_pawn_value_last[2][2][8];
extern int passed_pawn_candidate[2][2][8];
extern int passed_pawn_candidate_last[2][2][8];
extern int connected_passed_pawn_value[2];
extern int connected_passed_pawn_value_last[2];
extern int blockading_passed_pawn_value[2][2][8];
extern int blockading_passed_pawn_value_last[2][2][8];
extern int pp_rank_bonus[8];
extern int pp_dist_bonus[8];
extern int pp_rank_bonus_last[8];
extern int pp_dist_bonus_last[8];
extern int passed_pawn_hidden[2];
extern int passed_pawn_hidden_last[2];
extern int doubled_pawn_value[2][8];
extern int doubled_pawn_value_last[2][8];
extern int outside_passed[2];
extern int outside_passed_last[2];
extern int pawn_defects[2][8];
extern int pawn_defects_last[2][8];
extern int open_file[8];
extern int open_file_last[8];
extern int half_open_file[8];
extern int half_open_file_last[8];
extern int material_imbalance[9][9];
extern int king_tropism_n[8];
extern int king_tropism_n_last[8];
extern int king_tropism_b[8];
extern int king_tropism_b_last[8];
extern int king_tropism_r[8];
extern int king_tropism_r_last[8];
extern int king_tropism_q[8];
extern int king_tropism_q_last[8];
extern int friendly_q[8];
extern int pval[2][2][64];
extern int pval_last[2][2][64];
extern int nval[2][2][64];
extern int nval_last[2][2][64];
extern int bval[2][2][64];
extern int bval_last[2][2][64];
extern int qval[2][2][64];
extern int qval_last[2][2][64];
extern int kval_n[2][64];
extern int kval_n_last[2][64];
extern int kval_k[2][64];
extern int kval_k_last[2][64];
extern int kval_q[2][64];
extern int kval_q_last[2][64];
extern int king_safety[16][16];
extern int mob_curve_r[48];
extern int mob_curve_r_last[48];
extern int safety_vector[16];
extern int safety_vector_last[16];
extern int tropism_vector[16];
extern int tropism_vector_last[16];
extern const char b_n_mate_dark_squares[64];
extern const char b_n_mate_light_squares[64];
extern const int mate[64];
extern BITBOARD magic_rook[64];
extern BITBOARD magic_rook_mask[64];
extern unsigned magic_rook_shift[64];
extern BITBOARD mobility_mask_n[4];
extern BITBOARD mobility_mask_b[4];
extern BITBOARD mobility_mask_r[4];
extern BITBOARD *magic_rook_indices[64];
extern BITBOARD magic_rook_table[102400];
extern BITBOARD magic_bishop[64];
extern BITBOARD magic_bishop_mask[64];
extern unsigned magic_bishop_shift[64];
extern BITBOARD *magic_bishop_indices[64];
extern BITBOARD magic_bishop_table[5248];
extern signed char directions[64][64];
extern BITBOARD pawn_attacks[2][64];
extern BITBOARD knight_attacks[64];
extern POSITION display;
extern BITBOARD king_attacks[64];
extern BITBOARD obstructed[64][64];
extern BITBOARD randoms[2][7][64];
extern BITBOARD castle_random[2][2];
extern BITBOARD enpassant_random[MAXPLY];
extern BITBOARD wtm_random[2];
extern BITBOARD clear_mask[MAXPLY];
extern BITBOARD set_mask[MAXPLY];
extern BITBOARD file_mask[8];
extern BITBOARD rank_mask[8];
extern BITBOARD OO[2];
extern BITBOARD OOO[2];
extern BITBOARD mask_efgh, mask_fgh, mask_abc, mask_abcd;
extern BITBOARD mask_advance_2_w;
extern BITBOARD mask_advance_2_b;
extern BITBOARD mask_can_promote_w;
extern BITBOARD mask_can_promote_b;
extern BITBOARD mask_left_edge;
extern BITBOARD mask_right_edge;
extern BITBOARD mask_not_edge;
extern BITBOARD mask_kr_trapped[2][3];
extern BITBOARD mask_qr_trapped[2][3];
extern BITBOARD mask_space[2];
extern BITBOARD mask_board_quarter[4];
extern BITBOARD dark_squares;
extern BITBOARD not_rook_pawns;
extern BITBOARD rook_pawns;
extern BITBOARD plus1dir[MAXPLY];
extern BITBOARD plus7dir[MAXPLY];
extern BITBOARD plus8dir[MAXPLY];
extern BITBOARD plus9dir[MAXPLY];
extern BITBOARD minus1dir[MAXPLY];
extern BITBOARD minus7dir[MAXPLY];
extern BITBOARD minus8dir[MAXPLY];
extern BITBOARD minus9dir[MAXPLY];
extern BITBOARD mask_eptest[64];
extern BITBOARD mask_clear_entry;
extern int history[2][512];
extern KILLER counter_move[4096];
extern KILLER move_pair[4096];
#  if !defined(_M_AMD64) && !defined (_M_IA64) && !defined(INLINE32) || defined(VC_INLINE)
extern unsigned char msb[65536];
extern unsigned char lsb[65536];
#  endif
extern unsigned char msb_8bit[256];
extern unsigned char lsb_8bit[256];
extern unsigned char pop_cnt_8bit[256];
extern signed char is_outside[256][256];
extern BITBOARD mask_pawn_connected[2][64];
extern BITBOARD mask_pawn_duo[64];
extern BITBOARD mask_pawn_isolated[64];
extern BITBOARD mask_pawn_passed[2][64];
extern BITBOARD mask_no_pattacks[2][64];
extern BITBOARD mask_hidden_left[2][8];
extern BITBOARD mask_hidden_right[2][8];
extern BITBOARD pawn_race[2][2][64];
extern BOOK_POSITION book_buffer[BOOK_CLUSTER_SIZE];
extern BOOK_POSITION book_buffer_char[BOOK_CLUSTER_SIZE];
extern const int rankflip[2][8];
extern const int sqflip[2][64];
extern const BITBOARD rank12[2];
extern const int sign[2];
extern int direction[2];
extern int dark_corner[2];
extern int light_corner[2];
extern int OOsqs[2][3];
extern int OOOsqs[2][3];
extern int OOfrom[2];
extern int OOto[2];
extern int OOOto[2];
extern int epsq[2];
extern int rook_A[2];
extern int rook_D[2];
extern int rook_F[2];
extern int rook_G[2];
extern int rook_H[2];
extern int capleft[2];
extern int capright[2];
extern int pawnadv1[2];
extern int pawnadv2[2];

#  if !defined(NOEGTB)
extern int cbEGTBCompBytes;
#  endif
extern int pawn_value;
extern int pawn_value_last;
extern int knight_value;
extern int knight_value_last;
extern int bishop_value;
extern int bishop_value_last;
extern int rook_value;
extern int rook_value_last;
extern int queen_value;
extern int queen_value_last;
extern int imbalance_minor;
extern int imbalance_minor_last;
extern int imbalance_major;
extern int imbalance_major_last;
extern int imbalance_minor_major;
extern int imbalance_minor_major_last;
extern int imbalance_max_score;
extern int imbalance_max_score_last;
extern int bishop_pair[2];
extern int bishop_pair_last[2];
extern int tot_mat;
extern int Kp;
extern int king_value;
extern int piece_values[2][7];
extern int bad_trade_last;
extern int eg_mat;
extern int eg_mat_last;
extern int wtm_bonus[2];
extern int wtm_bonus_last[2];
extern int lower_n;
extern int lower_n_last;
extern int lower_b;
extern int lower_b_last;
extern int lower_r;
extern int lower_r_last;
extern int lower_q;
extern int lower_q_last;
extern int mobility_score_b[2][4];
extern int mobility_score_b_last[2][4];
extern int mobility_score_n[4];
extern int mobility_score_n_last[4];
extern int mobility_score_r[4];
extern int mobility_score_r_last[4];
extern int mobility_score_q[4];
extern int mobility_score_q_last[4];
extern int undeveloped_piece;
extern int undeveloped_piece_last;
extern int development_space;
extern int development_space_last;
extern int friendly_queen[8];
extern int friendly_queen_last[8];
extern int pawn_can_promote;
extern int pawn_can_promote_last;
extern int trousers_bonus;
extern int trousers_bonus_last;
extern int pawn_duo[2];
extern int pawn_duo_last[2];
extern int pawn_unsupported[2];
extern int pawn_unsupported_last[2];
extern int pawn_isolated[2];
extern int pawn_isolated_last[2];
extern int pawn_isolated_open_file[2];
extern int pawn_isolated_open_file_last[2];
extern int king_king_tropism;
extern int king_king_tropism_last;
extern int bishop_trapped;
extern int bishop_trapped_last;
extern int bishop_pawns_on_color[2];
extern int bishop_pawns_on_color_last[2];
extern int bishop_with_wing_pawns[2];
extern int bishop_with_wing_pawns_last[2];
extern int rook_on_7th[2];
extern int rook_on_7th_last[2];
extern int connected_rook_value[2];
extern int connected_rook_value_last[2];
extern int rook_open_file[2];
extern int rook_open_file_last[2];
extern int rook_half_open_file[2];
extern int rook_half_open_file_last[2];
extern int rook_behind_passed_pawn[2][8];
extern int rook_behind_passed_pawn_last[2][8];
extern int rook_trapped;
extern int rook_trapped_last;
extern int king_safety_mate_threat;
extern int king_safety_mate_threat_last;
extern int development_thematic;
extern int development_thematic_last;
extern int development_losing_castle;
extern int development_losing_castle_last;
extern int development_not_castled;
extern int development_not_castled_last;
extern int development_early_queen;
extern int development_early_queen_last;
extern struct personality_term personality_packet[256];
#endif

#if defined(_WIN32) || defined(_WIN64)
#include "evaluatedll.h"
extern char *(__cdecl *pEvaluateDll_GetId)(void);
extern void (__cdecl *pEvaluateDll_Initialize)(void);
extern int (__cdecl *pEvaluateDll_Evaluate)(char *pos);
#endif
