#if !defined(VCINLINE_INCLUDED)
#  define VCINLINE_INCLUDED

#include "chess.h"
#include "data.h"
#if defined(_WIN64)
#include <intrin.h>
#endif

#if defined(_WIN64)
/*extern unsigned char _BitScanReverse64(unsigned long *, unsigned __int64);
extern unsigned char _BitScanForward64(unsigned long *, unsigned __int64);*/
#pragma intrinsic (_BitScanReverse64)
#pragma intrinsic (_BitScanForward64)
#endif

///////////////////////////////////////////////////////////////////////////
#if defined(_WIN32) || defined(_WIN64)
__forceinline int PopCnt(BITBOARD a)
{
#if defined(_WIN64) // _WIN64
#if defined(_DOUSE_AVX2) || defined(_DOUSE_SSE41) // AVX2 or SSE41
  return ((int)__popcnt64((unsigned __int64)a));
#else
  if (popcnt64)
    return ((int)__popcnt64((unsigned __int64)a));
  else {
    static const BITBOARD m1 = 0x5555555555555555;
    static const BITBOARD m2 = 0x3333333333333333;
    static const BITBOARD m4 = 0x0f0f0f0f0f0f0f0f;
    a -= (a >> 1) & m1;
    a = (a & m2) + ((a >> 2) & m2);
    a = (a + (a >> 4)) & m4;
    a += a >>  8;
    a += a >> 16;
    a += a >> 32;
    return (a & 0x7f);
  }
#endif
#else // _WIN32
  static const BITBOARD m1 = 0x5555555555555555;
  static const BITBOARD m2 = 0x3333333333333333;
  static const BITBOARD m4 = 0x0f0f0f0f0f0f0f0f;
  a -= (a >> 1) & m1;
  a = (a & m2) + ((a >> 2) & m2);
  a = (a + (a >> 4)) & m4;
  a += a >>  8;
  a += a >> 16;
  a += a >> 32;
  return (a & 0x7f);
  /*static const unsigned int c1 = 0xFFFFFFFF;
  static const unsigned int c2 = 0x55555555;
  static const unsigned int c3 = 0x33333333;
  static const unsigned int c4 = 0x0F0F0F0F;
  static const unsigned int c5 = 0x01010101;
  register unsigned int v1, v2;
  v1 = (unsigned int)(a & c1);
  v1 -= (v1 >> 1) & c2;
  v1 = (v1 & c3) + ((v1 >> 2) & c3);
  v1 = (v1 + (v1 >> 4)) & c4;
  v2 = (unsigned int)(a >> 32);
  v2 -= (v2 >> 1) & c2;
  v2 = (v2 & c3) + ((v2 >> 2) & c3);
  v2 = (v2 + (v2 >> 4)) & c4;
  return ((v1 * c5) >> 24) + ((v2 * c5) >> 24);*/
//This uses fewer arithmetic operations than any other known
//implementation on machines with slow multiplication.
//It uses 17 arithmetic operations.
  /*static const BITBOARD m1 = 0x5555555555555555;
  static const BITBOARD m2 = 0x3333333333333333;
  static const BITBOARD m4 = 0x0f0f0f0f0f0f0f0f;
  a -= (a >> 1) & m1;
  a = (a & m2) + ((a >> 2) & m2);
  a = (a + (a >> 4)) & m4;
  a += a >>  8;
  a += a >> 16;
  a += a >> 32;
  return (a & 0x7f);*/
//This uses fewer arithmetic operations than any other known
//implementation on machines with fast multiplication.
//It uses 12 arithmetic operations, one of which is a multiply.
  /*static const BITBOARD m1 = 0x5555555555555555;
  static const BITBOARD m2 = 0x3333333333333333;
  static const BITBOARD m4 = 0x0f0f0f0f0f0f0f0f;
  static const uint64_t h01 = 0x0101010101010101;
  a -= (a >> 1) & m1;
  a = (a & m2) + ((a >> 2) & m2);
  a = (a + (a >> 4)) & m4;
  return ((a * h01) >> 56);*/
#endif
}
#endif

///////////////////////////////////////////////////////////////////////////
#if defined(_WIN32) || defined(_WIN64)
__forceinline int LSB(BITBOARD a)
{
#if defined(_WIN64) // _WIN64
  int r;
  if (_BitScanForward64((unsigned long *)&r, (unsigned __int64)a))
    return (r);
  else
    return (64);
#else // _WIN32
  if (a & 65535)
    return (lsb[a & 65535]);
  if ((a >> 16) & 65535)
    return (lsb[(a >> 16) & 65535] + 16);
  if ((a >> 32) & 65535)
    return (lsb[(a >> 32) & 65535] + 32);
  return (lsb[a >> 48] + 48);
#endif
}
#endif

///////////////////////////////////////////////////////////////////////////
#if defined(_WIN32) || defined(_WIN64)
__forceinline int MSB(BITBOARD a)
{
#if defined(_WIN64) // _WIN64
  int r;
  if (_BitScanReverse64((unsigned long *)&r, (unsigned __int64)a))
    return (r);
  else
    return (64);
#else // _WIN32
  if (a >> 48)
    return (msb[a >> 48] + 48);
  if ((a >> 32) & 65535)
    return (msb[(a >> 32) & 65535] + 32);
  if ((a >> 16) & 65535)
    return (msb[(a >> 16) & 65535] + 16);
  return (msb[a & 65535]);
#endif
}
#endif

#endif
